<?php
/*
Plugin Name: External Nofollow
Plugin URI: http://www.deluxeblogtips.com/2010/04/external-nofollow-wordpress-plugin.html
Description: Add rel="nofollow" to all external links in post content
Version: 1.0
Author: Rilwis
Author URI: http://www.deluxeblogtips.com

Copyright 2010 Rilwis (email: rilwis@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (!class_exists('ExternalNofollow')) {
	class ExternalNofollow
	{
		static function init()
		{
			add_filter('the_content', array(__CLASS__, 'nofollow'));
		}

		function nofollow($content)
		{
			//return stripslashes(wp_rel_nofollow($content));
			
			return preg_replace_callback('/<a[^>]+/', array(__CLASS__, 'callback'), $content);
		}

		function callback($matches)
		{
			$link = $matches[0];
			$site_link = get_bloginfo('url');

			if (strpos($link, 'rel') === false) {
				$link = preg_replace("%(href=\S(?!$site_link))%i", 'rel="nofollow" $1', $link);
			} elseif (preg_match("%href=\S(?!$site_link)%i", $link)) {
				$link = preg_replace('/rel=\S(?!nofollow)\S*/i', 'rel="nofollow"', $link);
			}
			
			return $link;
		}
	}
	
	ExternalNofollow::init();
}
?>
